package com.AltecAir.CycleKit.web;

import java.io.File;
import java.io.IOException;

import com.AltecAir.Common.org.nanohttpd.protocols.http.NanoHTTPD;
import com.AltecAir.Common.org.nanohttpd.webserver.SimpleWebServer;
import com.AltecAir.Common.util.NetworkTools;
import com.AltecAir.CycleKit.System.CycleKit;
import com.AltecAir.CycleKit.states.InterfaceStateMachine;

public class Server extends SimpleWebServer
{

	public Server(CycleKit cycleKit, InterfaceStateMachine stateMachine)
	{
		super(NetworkTools.IPToStringNoSpaces(cycleKit.getNetwork().getIPAddress()), 443, new File("/home/pi/web/"), true,stateMachine);
		System.out.println("A new Server instance");
		try
		{


			
			this.makeSecure(NanoHTTPD.makeSSLSocketFactory("/home/pi/csa/cyclekit.jks",
			        "?C-dc5U_ue-@7Jq_".toCharArray()), null);

			super.start();
		} catch (IOException e)
		{
			// TODO listen on random port, and let orphan NanoHTTPD thread close
			// themselves.
			throw new RuntimeException(e);
		} 
	}

}
