var lastJQueryTS = 0;

var cycleMode = "";
var cycleDaysToSwitch = "";
var skipWeekend = false;
var minimumDryersOnline = 1;

var rosterStatusArray = new Array(9);
var portDeviceIDArray = new Array(9);
var displayAddPortFlag;

var changeoverDelay = 0;


function updatePorts() 
{
	var i;
	var html = '';
	var htmlAddPort = '';
	rosterStatusArray=[];
	portDeviceIDArray=[];
	displayAddPortFlag = false;
	for(i = 0; i < cycleKit.ports.length; i++)
	{
		var dryerStatus = cycleKit.ports[i].currentState;
		rosterStatusArray[cycleKit.ports[i].dryerNumber]=cycleKit.ports[i].rosterState;
		portDeviceIDArray[cycleKit.ports[i].dryerNumber]=cycleKit.ports[i].portDeviceID;	
		var rosterStatus = cycleKit.ports[i].rosterState;
		var dryerColor = '';
		var dryerResetEnable = '';
		var alarm = `<img src="WebLibraries/Style-Libraries/fontawesome/svgs/solid/alarm-red.svg" style = "width: 50px;">`;
		var online = `<img src="WebLibraries/Style-Libraries/fontawesome/svgs/solid/running-green.svg" style = "width: 50px;">`;
		var standby = `<img src="WebLibraries/Style-Libraries/fontawesome/svgs/solid/standby-yellow.svg" style = "width: 50px;">`;
		var emergency = `<img src="WebLibraries/Style-Libraries/fontawesome/svgs/solid/emergency-blue.svg" style = "width: 50px;">`;
		var exercise = `<img class = "alarm" src="WebLibraries/Style-Libraries/fontawesome/svgs/solid/exercise-blue.svg" style = "width: 50px;">`;
		var maintenance = `<img class = "alarm" src="WebLibraries/Style-Libraries/fontawesome/svgs/solid/maintenance-blue.svg" style = "width: 45px;">`;
		var connected = `<img src="WebLibraries/Style-Libraries/fontawesome/svgs/solid/connected-blue.svg" style = "width: 50px;">`;
		var disconnected = `<img class = "alarm" src="WebLibraries/Style-Libraries/fontawesome/svgs/solid/disconnected-red.svg" style = "width: 50px;">`;

		var connectIcon = ''

		switch(dryerStatus) {
			  case "ALARM":
				dryerColor = `aa-color-alert`;
				connectIcon = alarm;
				dryerResetEnable = `<div class="row" style="margin: 0px;padding-top: 5px;">
											<button type="button" class="btn aa-button" style="margin: 1px; width: 100%;" onclick="alarmReset(`+cycleKit.ports[i].dryerNumber+`)">RESET</button>
									</div>`;
				break;
			  case "ONLINE":
				dryerColor = `aa-color-success`;
				connectIcon = online;
				break;
			  case "DISCONNECTED":
				dryerColor = `aa-color-alert`;
				connectIcon = disconnected;
				break;
			  case "STANDBY":
				dryerColor = `aa-color-warning`;
				connectIcon = standby;
				break;
			  case "EMERGENCY":
				dryerColor = `aa-color-light`;
				connectIcon = emergency;
				break;
			  case "EXERCISE":
				dryerColor = `aa-color-light`;
				connectIcon = exercise;
				break;
			  case "MAINTENANCE":
				dryerColor = `aa-color-info`;
				connectIcon = maintenance;
				break;
			  case "CONNECTED":
				dryerColor = `aa-color-info`;
				connectIcon = connected;
				break;
			  default:
				dryerColor = 'black';
			}
			
				/* TILES */
		html +=	`<div class="card  rounded  bg-dark" style="border-radius: .75rem; margin: 2px; padding: 1px;">
					<div class="card-body bg-dark" style="padding: 8px;min-width: 236px;">
						<div class="row justify-content-between align-items-baseline" style="margin: 0px;">    <!-- PORT NUMBER -->
							<div class="col-10" style="padding: 0px;padding-left: 35px;">
								<h4 class = "text-center altec-yellow" style="font-size: 22px;">PORT `+cycleKit.ports[i].dryerNumber+`</h4>
							</div>
							<div class="col-2" style="padding: 0px;"></div>
						</div>
						<div class="row justify-content-between align-items-center" style="margin: 0px;">	  <!-- ID NAME -->
							<div class="col-3" style="padding: 0px;"><span style="color: rgb(255,255,255);font-style: normal;font-size: 18px;">ID:</span></div>
							<div class="col text-center" style="padding: 0px;"><strong style="color: rgb(255,255,255);font-size: 18px;">`+portDeviceIDArray[cycleKit.ports[i].dryerNumber]+`</strong></div>
							<div class="col-2" style="padding: 0px;">
								<button type="button" data-toggle="modal" onclick="updateModelID(`+cycleKit.ports[i].dryerNumber+`)" data-backdrop="static" data-keyboard="false" data-target="#modal-modelID-`+cycleKit.ports[i].dryerNumber+`" style="background-color:transparent; border-color:transparent; border:none;">
									<i class="fa fa-edit d-xl-flex justify-content-xl-end" data-toggle="tooltip" style="color: darkgoldenrod;font-size: 18px;" title="Change ID or model "></i>
								</button>
							</div>
						</div>
						<div class="row justify-content-between align-items-center" style="margin: 0px;">     <!-- ROSTER STATE -->
							<div class="col-3" style="padding: 0px;"><span style="color: rgb(255,255,255);font-style: normal;font-size: 18px;">Roster:</span></div>
							<div class="col text-center" style="padding: 0px;"><strong style="color: rgb(255,255,255);font-size: 16px;">`+rosterStatusArray[cycleKit.ports[i].dryerNumber]+`</strong></div>
							<div class="col-2" style="padding: 0px;">
								<button type="button" data-toggle="modal" onclick="updateRosterState(`+cycleKit.ports[i].dryerNumber+`)" data-backdrop="static" data-keyboard="false" data-target="#modal-settings-`+cycleKit.ports[i].dryerNumber+`" style="background-color:transparent; border-color:transparent; border:none;">
									<i class="fa fa-edit d-xl-flex justify-content-xl-end" data-toggle="tooltip" style="color: darkgoldenrod;font-size: 18px;" title="Change roster state"></i>
								</button>							
							</div>
						</div>
						<div class="row justify-content-between align-items-center" style="margin: 0px; height: 80px;">         <!-- FLASHING ICONS -->  
							<div class="col-4 text-left" style="padding: 0px;"><span style="color: rgb(255,255,255);font-style: normal;font-size: 18px;">Status:</span></div>
							<div class="col text-center" style="padding: 0px;">`+connectIcon+`</div>
							<div class="col-4" style="padding: 0px;"></div>
						</div>
						<div class="row" style="margin: 0px;">
							<div class="col">
								<h1 class="`+dryerColor+`" style="text-align: center;font-size: 25px;margin: 0px;">`+dryerStatus+`</h1>
							</div>
						</div>
						`+dryerResetEnable+`
					</div>
				</div>`;
		
	}
	/* CHECKS IF LESS THAN 8 PORTS */
	var port = document.getElementById('add-port');
	console.log("Add PORTS ON Modals");
	for(var i = 1; i<9; i++)
	{   
		if(!rosterStatusArray[i])
		{
			displayAddPortFlag = true;
			port.options[i-1].disabled = false;  // Display Port Number
		}
		else
		{
			port.options[i-1].disabled = true;  // Hide Port Number
			port.options[i-1].selected = false;  // Deselects Port Numbers
		}
		
	}
	
	/* DISPLAYS THE ADD BUTTON IF LESS THAN 8 PORTS */
	if (displayAddPortFlag)
	{	
		html +=		  '<div style="margin-left: 74px;margin-top: 20px;margin-right: 74px;margin-bottom: 20px;">';
		html +=			'<button type="button" data-toggle="modal" onclick="updateAvailablePorts()" data-backdrop="static" data-keyboard="false" data-target="#modal-add" class="btn btn-xl altec-yellow" style = "border-color: var(--aa-yellow-brand-color);"><i class="fa fa-plus" data-toggle="tooltip" style="color: var(--aa-yellow-brand-color); font-size: 80px;" title="Add PORT"></i></button>';
		html +=			'</div>';
	}
	


	document.getElementById("ports").innerHTML = html;
	
}

function createModals(){
	console.log("CreateModals");
	
	htmlModals = '';
	
	for(var i=1; i<9; i++)
	{
					/* MODAL FOR THE MODEL ID SETTING */
		htmlModals +=`<div class="modal fade text-center" id="modal-modelID-`+i+`">
					  <div class="modal-dialog modal-sm modal-dialog-centered" style="min-width: 255px;">
						<div class="modal-content" style="border-color: var(--aa-yellow-brand-color);min-width: 255px;">
						  <div class="modal-header">
							<h5 class="modal-title">Roster:&nbsp;&nbsp;PORT `+i+`</h5>
							<button type="button" class="close" data-dismiss="modal" aria-label="Close">
							  <span aria-hidden="true">&times;</span>
							</button>
						  </div>
						  <div class="modal-body">
							<div class="row">
                                <div class="col">
                                    <h6 class="altec-yellow">ID or Model</h6>
                                    <div id="serial-number" class="card-text aa-about-text">
                                        <p>
											<input class="form-control" id = "port-device-id-`+i+`" type = "text" maxlength = "10" placeholder="Type dryer model or Id" autocomplete="off">  
										</p>
                                    </div>
                                </div>
                            </div>
						  </div>
						  <div class="modal-footer">
							<button type="button" class="btn btn-danger" onclick="deleteModelID(`+i+`)"  data-dismiss="modal">Delete</button>
							<button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
							<button type="button" class="btn aa-button" onclick="setModelID(`+i+`)"  data-dismiss="modal">Save</button>
						  </div>
						</div>
					  </div>
					</div>`;
					
					/* MODAL FOR THE ROSTER SETTING */
		htmlModals +=`<div class="modal fade text-center" id="modal-settings-`+i+`">
					  <div class="modal-dialog modal-sm modal-dialog-centered" style="min-width: 255px;">
						<div class="modal-content" style="border-color: var(--aa-yellow-brand-color);min-width: 255px;">
						  <div class="modal-header">
							<h5 class="modal-title">Roster:&nbsp;&nbsp;PORT `+i+`</h5>
							<button type="button" class="close" data-dismiss="modal" aria-label="Close">
							  <span aria-hidden="true">&times;</span>
							</button>
						  </div>
						  <div class="modal-body">
								<div class="row">
									<div class="col">
										<h6 class="altec-yellow">Desired Roster State</h6>
									</div>
								</div>
							<select id="roster-state-`+i+`" class="custom-select" onchange = "displayExerciseShift(`+i+`)">
								<option style="color: var(--aa-green-color);" value="ONLINE">ONLINE</option>
								<option style="color: var(--aa-yellow-color);" value="STANDBY">STANDBY</option>
								<option style="color: var(--aa-light-color);" value="EMERGENCY">EMERGENCY</option>
								<option style="color: var(--aa-light-color);" value="EXERCISE">EXERCISE</option>
								<option style="color: var(--aa-blue-color);" value="MAINTENANCE">MAINTENANCE</option>
								<option style="color: var(--aa-red-color);" value="DISCONNECTED">DISCONNECTED</option>
							</select>
							<div id="exercise-select-`+i+`"></div>
						  </div>
						  <div class="modal-footer">
							<button type="button" class="btn btn-danger" onclick="deleteRosterState(`+i+`)"  data-dismiss="modal">Delete</button>
							<button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
							<button type="button" class="btn aa-button" onclick="setRosterState(`+i+`)"  data-dismiss="modal">Save</button>
						  </div>
						</div>
					  </div>
					</div>`;
	}
	
		
	/* MODAL FOR THE ADD BUTTON */
	htmlModals +=	`<div class="modal fade text-center" id="modal-add">
			  <div class="modal-dialog modal-sm modal-dialog-centered" role="document" style="min-width: 255px;">
				<div class="modal-content" style="border-color: var(--aa-yellow-brand-color);min-width: 255px;">
				  <div class="modal-header">
					<h5 class="modal-title">ADD PORT</h5>
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
					  <span aria-hidden="true">&times;</span>
					</button>
				  </div>
				  <div class="modal-body">
				  	<select id="add-port" class="custom-select">
						<option value="1">PORT 1</option>
						<option value="2">PORT 2</option>
						<option value="3">PORT 3</option>
						<option value="4">PORT 4</option>
						<option value="5">PORT 5</option>
						<option value="6">PORT 6</option>
						<option value="7">PORT 7</option>
						<option value="8">PORT 8</option>
					</select>
					<p></p>
					<select id="add-roster-state" class="custom-select">
						<option style="color: var(--aa-green-color);" value="ONLINE">ONLINE</option>
						<option style="color: var(--aa-yellow-color);" value="STANDBY">STANDBY</option>
						<option style="color: var(--aa-light-color);" value="EMERGENCY">EMERGENCY</option>
						<option style="color: var(--aa-blue-color);" value="MAINTENANCE">MAINTENANCE</option>
					</select>
				  </div>
				  <div class="modal-footer">
					<button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
					<button type="button" class="btn aa-button" onclick="addRosterState()" data-dismiss="modal">Save</button>
				  </div>
				</div>
			  </div>
			</div>`;
	
			
	document.getElementById("modals").innerHTML = htmlModals;
	
}

function updateStatus() {

	//console.log("updating status");
	if (document.getElementById('current-date-time') !== document.activeElement) 
	{
		document.getElementById('current-date-time').innerHTML = cycleKit.date[1] + '/' + cycleKit.date[2] + '/' + cycleKit.date[0] +
		' '+cycleKit.date[3].pad() + ':' + cycleKit.date[4].pad();
		document.getElementById('current-date').value = cycleKit.date[1] + '/' + cycleKit.date[2] + '/' + cycleKit.date[0] +
		' '+cycleKit.date[3].pad() + ':' + cycleKit.date[4].pad();
	}
	if (document.getElementById('next-cycle-time') !== document.activeElement) 
	{
		document.getElementById('next-cycle-time').innerHTML = cycleKit.nextCycleTime[1]+ '/' + cycleKit.nextCycleTime[2]+ '/' + cycleKit.nextCycleTime[0] +
		' '+cycleKit.nextCycleTime[3].pad() + ':' + cycleKit.nextCycleTime[4].pad();
		document.getElementById('next-cycle-edit').value = cycleKit.nextCycleTime[1] + '/' + cycleKit.nextCycleTime[2] + '/' + cycleKit.nextCycleTime[0] +
		' '+cycleKit.nextCycleTime[3].pad() + ':' + cycleKit.nextCycleTime[4].pad();
	}

	updateCycleMode();
	updateDaysToSwitch();
	updateMinimumDryersOnline();
		
	updateSkipWeekend();
	updateAlarmDelay();
	updateChangeoverDelay();

}


function updateMinimumDryersOnline() {
	var MinimumDryersOnlineHTML = document.getElementById('min_dryers');
	minimumDryersOnline = cycleKit.minimumDryersOnline;
	MinimumDryersOnlineHTML.selectedIndex = minimumDryersOnline-1;
	 $('.selectpicker').selectpicker('refresh')
}

function updateCycleMode() {

	var CycleModeHTML = document.getElementById('cycle_mode');
	//console.log(cycle_mode)
	cycleMode = cycleKit.mode;
	cycleDaysToSwitch = cycleKit.daysToSwitch;
	
	switch(cycleMode) {
	  case "TWENTY_FOUR_HOUR":
		  CycleModeHTML.options[0].selected = true;
		  $('.selectpicker').selectpicker('refresh')
		for(var i=0; i<7; i ++)
			{
				document.getElementById('bt_day'+ i).style.backgroundColor = "#bfbdbd";
				document.getElementById('bt_day'+ i).setAttribute("disabled", "disabled");
			}
		break;
	  case "FORTY_EIGHT_HOUR":
		  
		  CycleModeHTML.options[1].selected = true;
		  $('.selectpicker').selectpicker('refresh')
		for(var i=0; i<7; i ++)
			{
				document.getElementById('bt_day'+ i).style.backgroundColor = "#bfbdbd";
				document.getElementById('bt_day'+ i).setAttribute("disabled", "disabled");
			}
		break;
	  case "CUSTOM":
		  CycleModeHTML.options[2].selected = true;
		  $('.selectpicker').selectpicker('refresh')
		updateDaysToSwitch();
		break;
	  default:
		break;
	}
}

function kwOnKeyUp()
{
    var key = event.keyCode || event.charCode;
    var inputs = $('.currentkw');
    console.log("inputs: ",inputs);
    console.log(inputs);
    if((this.val().length === this.size) && key != 32)
    {
      inputs.eq(inputs.index(this) + 1).focus();  
    } 
    if( key == 8 || key == 46 )
    {
      var indexNum = inputs.index(this);
      if(indexNum != 0)
      {
      inputs.eq(inputs.index(this) - 1).val('').focus();
      }
    }
    
              if (this.value.length == this.maxLength) {
    var $next = $(this).next('.currentkw');
    if ($next.length)
        $(this).next('.currentkw').focus();
    else
        $(this).blur();
  }
}
function updateDaysToSwitch()
{
	if(skipWeekend)
	{
		document.getElementById('bt_day5').style.backgroundColor = "#33393F";	  // False GRAY
		document.getElementById('bt_day5').style.color = "#F8F9FA";   
		document.getElementById('bt_day6').style.backgroundColor = "#33393F";	  // False GRAY
		document.getElementById('bt_day6').style.color = "#F8F9FA";   
	}
	var indexes = fortyEightHourIndexes(cycleKit.nextCycleTime.dayOfWeek,skipWeekend);
	//console.log(indexes);
	for(var i=0; i<7; i ++)
	{
		if(cycleMode == "CUSTOM")
		{
			document.getElementById('bt_day'+ i).removeAttribute('disabled');
			if(cycleDaysToSwitch[i])
			{
				if(skipWeekend && (i == 5 || i == 6))
				{
					
					document.getElementById('bt_day'+ i).style.backgroundColor = "#33393F";	  // False GRAY
					document.getElementById('bt_day'+ i).style.color = "#F8F9FA";   
				}
				else
				{
					document.getElementById('bt_day'+ i).style.backgroundColor = "#EFB310";   // True Yellow
					document.getElementById('bt_day'+ i).style.color = "#101519";   
				}

			}
			else
			{
				document.getElementById('bt_day'+ i).style.backgroundColor = "#33393F";	  // False GRAY
				document.getElementById('bt_day'+ i).style.color = "#F8F9FA";   
			}
		}
		else if (cycleMode == "TWENTY_FOUR_HOUR")
		{

			if(skipWeekend && (i == 5 || i == 6))
			{
				
				document.getElementById('bt_day'+ i).style.backgroundColor = "#33393F";	  // False GRAY
				document.getElementById('bt_day'+ i).style.color = "#F8F9FA";   
			}
			else
			{
				document.getElementById('bt_day'+ i).style.backgroundColor = "#EFB310";   // True Yellow
				document.getElementById('bt_day'+ i).style.color = "#101519";   
			}
		}
		else if (cycleMode == "FORTY_EIGHT_HOUR")
		{
			
			if(i == indexes[0] || i == indexes[1] || i == indexes[2])
			{
				document.getElementById('bt_day'+ i).style.backgroundColor = "#EFB310";   // True Yellow
				document.getElementById('bt_day'+ i).style.color = "#101519";   
			}
			else
			{
				document.getElementById('bt_day'+ i).style.backgroundColor = "#33393F";	  // False GRAY
				document.getElementById('bt_day'+ i).style.color = "#F8F9FA";   
			}


		}
		
	}

}

function fortyEightHourIndexes(startingDay,weekendsDisabled)
{
	var indexes = [0,0,0];
	var dayNumber = dayNumberFromString(startingDay);
	indexes[0] = dayNumber;
	if(!weekendsDisabled)
	{
		for(var i = 0; i < 2; i++)
		{
			dayNumber = (dayNumber + 2)%7;
			indexes[i+1] = dayNumber;
		}
	}
	else
	{
		for(var i = 0; i < 2; i++)
		{
			dayNumber = (dayNumber + 2)%5;
			indexes[i+1] = dayNumber;
		}
	}

	return indexes;
}
function dayNumberFromString(dayOfWeek)
{
	switch(dayOfWeek)
	{
		case "MONDAY":
			return 0;
		break;
		case "TUESDAY":
			return 1;
		break;
		case "WEDNESDAY":
			return 2;
		break;
		case "THURSDAY":
			return 3;
		break;
		case "FRIDAY":
			return 4;
		break;
		case "SATURDAY":
			return 5;
		break;
		case "SUNDAY":
			return 6;
		break;
		default:
		break;		
		
	}
}
function updateAlarmDelay() {
	
	alarmDelay = cycleKit.alarmDelay;
	var AlarmDelayOnlineHTML = document.getElementById('alarm_delay');
	AlarmDelayOnlineHTML.selectedIndex = alarmDelay;
	 $('.selectpicker').selectpicker('refresh')
	
}

function updateChangeoverDelay() {
	
	changeoverDelay = cycleKit.changeoverDelay;
	var ChangeoverDelayOnlineHTML = document.getElementById('changeover_delay');
	ChangeoverDelayOnlineHTML.selectedIndex = changeoverDelay;
	 $('.selectpicker').selectpicker('refresh')
	
}

function updateSkipWeekend() {
	skipWeekend = cycleKit.skipWeekend;
	
	if(skipWeekend)
	{
		cycleDaysToSwitch[5] = false;
		cycleDaysToSwitch[6] = false;
		document.getElementById('bt_day'+ 5).style.backgroundColor = "#bfbdbd"; // False GRAY
		document.getElementById('bt_day'+ 6).style.backgroundColor = "#bfbdbd"; // False GRAY
		document.getElementById('bt_day'+ 5).setAttribute("disabled", "disabled");
		document.getElementById('bt_day'+ 6).setAttribute("disabled", "disabled");
		document.getElementById('skip-weekends').checked = true;
	}
	else {
		if(cycleMode == "CUSTOM")
		{
			document.getElementById('bt_day'+ 5).removeAttribute('disabled');
			document.getElementById('bt_day'+ 6).removeAttribute('disabled');
		}
		document.getElementById('skip-weekends').checked = false;
	}

}

function updateLCDDim() {
	var dim = cycleKit.dimEnabled;
	
	if(dim)
	{

		document.getElementById('lcd-dim').checked = true;
	}
	else {

		document.getElementById('lcd-dim').checked = false;
	}

}

function updateModelID(id){
	console.log("updateModelID:");
		
	var p = document.getElementById('port-device-id-'+ id);
	console.log("portDeviceIDArray for " + id + " is: " );
	console.log(portDeviceIDArray[id]);
	
	p.value = portDeviceIDArray[id];
}


function updateRosterState(id){
	console.log("updateRosterState:");
		
	var x = document.getElementById('roster-state-'+ id);
	
	if(document.getElementById('exercise-shift-'+id))
		{
			document.getElementById('exercise-shift-'+id).remove();
		}
		
    for ( var i = 0, len = x.options.length; i < len; i++ ) {

        if ( x.options[i].value == rosterStatusArray[id]) {
			if(rosterStatusArray[id] == "EMERGENCY" || rosterStatusArray[id] == "EXERCISE")
			{
				console.log("Display Exercise Option");
				x.options[3].disabled = false;  // Display Exercise Hours
			}
			else{
				console.log("Hide Exercise Hours");
				x.options[3].disabled = true;	// Hide Exercise Hours
			}
			
			x.options[i].selected = true;
            break;
        }
		else
		{
			x.options[i].selected = false;
		}
    }
}

function displayExerciseShift(id){
	var x = document.getElementById('roster-state-'+ id);
	
		if(document.getElementById('exercise-shift-'+id))
		{
			document.getElementById('exercise-shift-'+id).remove();
		}
	
	if(x.selectedIndex == 3)
	{
		//console.log("Display Exercise Shift");
		
		htmlExercise =`<select id="exercise-shift-`+id+`" class="custom-select" style = "margin-top: 15px;">
						<option value="4">4 Hours</option>
						<option value="8">8 Hours</option>
						<option value="16">16 Hours</option>
						<option value="20">20 Hours</option>
						<option value="24">24 Hours</option>
					</select>`;
	//console.log(htmlExercise);
	document.getElementById('exercise-select-'+id).innerHTML = htmlExercise;
	
	}
	else
	{
		console.log("Hide Exercise Shift");
		if(document.getElementById('exercise-shift-'+id))
		{
			document.getElementById('exercise-shift-'+id).remove();
		}
		

	}
}


function updateAvailablePorts(){

}


function setCycleMode() {

	var cycleMode = document.getElementById('cycle_mode');

	var mode = cycleMode.options[cycleMode.selectedIndex].value;
	if(locked)
	{
		keywordAttempt();
	}
	switch(mode) {
		case "24 Hour":
			sendCommand(socket,"SET CYCLE MODE", "24 HR");
		break;
		case "48 Hour":
			sendCommand(socket,"SET CYCLE MODE", "48 HR");
		break;
		case "Custom":
			sendCommand(socket,"SET CYCLE MODE", "CUSTOM");
		break;
		default:
			break;
	}

}


function setDaysToSwitch(day) 
{
	if(locked)
	{
		keywordAttempt();
	}
		//console.log(cycleMode);
		var count = 0;
		if(cycleMode == "CUSTOM")
		{
			if(cycleDaysToSwitch[day])
			{
				//see if there is more than 1 day enabled
				for (var i = 0; i < cycleDaysToSwitch.length; i++) 
				{
					if(cycleDaysToSwitch[i])
					{
						count++;
					}
				}
				//if there is, go ahead and disable this day, if not do nothing
				if(count > 1)
				{
					cycleDaysToSwitch[day] = false;
				}
				
			}
			else
			{
				cycleDaysToSwitch[day] = true;
			}
			if(locked)
			{
				keywordAttempt();
			}

			sendCommand(socket,"SET CYCLE DAYS", cycleDaysToSwitch);

		}
	
	
}

function setMinimumDryersOnline()
{
	if(locked)
	{
		keywordAttempt();
	}
	
	minimumDryersOnline = document.getElementById('min_dryers').value;
	sendCommand(socket,"SET MIN DRYERS", minimumDryersOnline);
}

function setAlarmDelay()
{
	if(locked)
	{
		keywordAttempt();
	}
	
	delay = document.getElementById('alarm_delay').value;
	sendCommand(socket,"SET ALARM DELAY", delay);
}

function setChangeoverDelay()
{
	if(locked)
	{
		keywordAttempt();
	}
	
	delay = document.getElementById('changeover_delay').value;
	sendCommand(socket,"SET CHANGEOVER DELAY", delay);
}

function setSkipWeekend()
{
	if(locked)
	{
		keywordAttempt();
	}
	if(document.getElementById('skip-weekends').checked == true)
	{
		skipWeekend = true;
		sendCommand(socket, "SET SKIP WEEKEND",true);
	}
	else
	{
		skipWeekend = false;
		sendCommand(socket, "SET SKIP WEEKEND",false);
	}
	
}
function setLCDDim()
{
	if(locked)
	{
		keywordAttempt();
	}
	if(document.getElementById('lcd-dim').checked == true)
	{
		sendCommand(socket, "SET LCD DIM",true);
	}
	else
	{
		sendCommand(socket, "SET LCD DIM",false);
	}
	
}

function setRosterState(id)
{

	if(locked)
	{
		keywordAttempt();
	}
	var Port = new Array(3);
	
	Port[0] = id-1;
	Port[1] = document.getElementById('roster-state-' + id).value;
	if(document.getElementById('exercise-shift-' + id))
	{
		Port[2] = document.getElementById('exercise-shift-' + id).value;
	}
	else
	{
		Port[2] =0;
	}

	sendCommand(socket,"SET DESIRED ROSTER", Port);
	console.log("setRosterState");
}

function setModelID(id)
{

	if(locked)
	{
		keywordAttempt();
	}
	var PortID = new Array(2);
	
	PortID[0] = id-1;
	PortID[1] = document.getElementById('port-device-id-' + id).value;
	
	sendCommand(socket,"SET PORT ID", PortID);
	console.log("setModelID");
		console.log(PortID);
}

function deleteModelID(id)
{
	if(locked)
	{
		keywordAttempt();
	}
	var PortID = new Array(2);
	
	PortID[0] = id-1;
	PortID[1] = "N/A";

	sendCommand(socket,"SET PORT ID", PortID);
	console.log("deleteModelID");
}

function deleteRosterState(id)
{
	if(locked)
	{
		keywordAttempt();
	}
	var Port = new Array(3);
	Port[0] = id-1;
	Port[1] = "DISCONNECTED";
	Port[2] =0;


	sendCommand(socket,"SET DESIRED ROSTER", Port);
	console.log("deleteRosterState");
}

function alarmReset(value)
{
	if(locked)
	{
		keywordAttempt();
	}
	//console.log("Alarm Reset: ");
	//console.log(value);
	sendCommand(socket, "SET ALARM RESET",value-1);
	
}

function addRosterState()
{
	if(locked)
	{
		keywordAttempt();
	}

	var Port = new Array(3);
	Port[0] =(document.getElementById('add-port').value)-1;
	Port[1] = document.getElementById('add-roster-state').value;
	Port[2] =0;
	/*
	console.log("Add Port: ");
	console.log(Port[0]);
	console.log(Port[1]);
*/
	//$('#modal-add').modal('hide');
	//$('body').removeClass('modal-open');
	
	sendCommand(socket,"SET DESIRED ROSTER", Port);
}


function setCurrentDateTime() 
{
	var date = document.getElementById('current-date');
	console.log(date.value);
	if (isValidDate(date.value)) {
		if(locked)
		{
			keywordAttempt();
		}
		sendCommand(socket,"SET DATE", date.value);
		date.blur()
	}
	else 
	{
		date.blur();
		alert("Incorrect Date Format (Use mm/dd/yyyy HH:MM)");
	}
	
}

function setNextCycleTime() {
	var date = document.getElementById('next-cycle-edit');

			if (isValidDate(date.value)) {
				if(locked)
				{
					keywordAttempt();
				}
				sendCommand(socket,"SET NEXT CYCLE", date.value);
				date.blur()
			}
			else {
				date.blur();
				alert("Incorrect Date Format (Use mm/dd/yyyy HH:MM)");
			}
}

function clearKW()
{
	document.getElementById('newkwrepeat').value = "";
	document.getElementById('newkw').value = "";
	document.getElementById('oldkw').value = "";	
}

function changeKW()
{
	var kwRepeat = document.getElementById('newkwrepeat').value;
	var kw = document.getElementById('newkw').value;
	var oldkw = document.getElementById('oldkw').value;
	
	document.getElementById('newkwrepeat').value = "";
	document.getElementById('newkw').value = "";
	document.getElementById('oldkw').value = "";
	
	sendCommand(socket,"CHANGE KEYWORD",oldkw +","+kw);

}
function checkPasswordsMatch()
{
	var kwRepeat = document.getElementById('newkwrepeat').value;
	var kw = document.getElementById('newkw').value;

	if(kw.length == 0)
	{
		document.getElementById("kw-dont-match").style.display = 'block';
		document.getElementById("changekwbttn").disabled = true
		document.getElementById("newkwrepeat").style.borderColor = "red";
		document.getElementById("newkw").style.borderColor = "red";
	}
	else if(kwRepeat == kw)
	{
		
		document.getElementById("kw-dont-match").style.display = 'none';
		document.getElementById("changekwbttn").disabled = false
		document.getElementById("newkwrepeat").style.borderColor = "green";
		document.getElementById("newkw").style.borderColor = "green";
		
	}
	else
	{
		document.getElementById("kw-dont-match").style.display = 'block';
		document.getElementById("changekwbttn").disabled = true
		document.getElementById("newkwrepeat").style.borderColor = "red";
		document.getElementById("newkw").style.borderColor = "red";
	}
}

function isValidDate(dateString) {
	
	var dateAndTime = dateString.split(" ");
	// First check for the pattern
	if (!/^\d{1,2}\/\d{1,2}\/\d{4}$/.test(dateAndTime[0]))
		return false;


	// Parse the date parts to integers
	var parts = dateAndTime[0].split("/");
	var day = parseInt(parts[1], 10);
	var month = parseInt(parts[0], 10);
	var year = parseInt(parts[2], 10);

	// Check the ranges of month and year
	if (year < 1000 || year > 3000 || month == 0 || month > 12)
		return false;

	var monthLength = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

	// Adjust for leap years
	if (year % 400 == 0 || (year % 100 != 0 && year % 4 == 0))
		monthLength[1] = 29;

	// Check the range of the day
	if(day > 0 && day <= monthLength[month - 1])
	{
		//check time format
		if (/^(0[1-9]|[1-5]?[0-9]):[0-5][0-9]$/.test(dateAndTime[1]))
			return true;
	}
};

function checkTimeFormat(form) {
	re = /^(0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$/
	if (form.value != '') {
		if (regs = form.value.match(re)) {
			if (regs[1] > 23 || regs[2] > 59) {
				return false;
			}
			else {
				return true;
			}
		}
		else {
			return false;
		}
	}
	else {
		return false;
	}
}
//Restricts input for the given textbox to the given inputFilter.
function setInputFilter(textbox, inputFilter) {
  ["input", "keydown", "keyup", "mousedown", "mouseup", "select", "contextmenu", "drop"].forEach(function(event) {
    textbox.addEventListener(event, function() {
      if (inputFilter(this.value)) {
        this.oldValue = this.value;
        this.oldSelectionStart = this.selectionStart;
        this.oldSelectionEnd = this.selectionEnd;
      } else if (this.hasOwnProperty("oldValue")) {
        this.value = this.oldValue;
        this.setSelectionRange(this.oldSelectionStart, this.oldSelectionEnd);
      } else {
        this.value = "";
      }
    });
  });
}

