$(function() {
    var debug = true;
    console.log("Here");
    // new kw form
    var $form = $("#form");

    // pincode group
    var $group = $form.find(".form__pincode");

    var $oldKWGroup = $form.find(".oldkeyword");
    var $newKWGroup = $form.find(".newkeyword");
    var $repeatKWGroup = $form.find(".repeatkeyword");

    // all input fields
    var $inputs = $group.find(":input");
    var $old_input = $oldKWGroup.find(":input");
    var $new_input = $newKWGroup.find(":input");
    var $repeat_input = $repeatKWGroup.find(":input");

    // input fields
    var $old1 = $form.find("[name=old-kw-1]"),
        $old2 = $form.find("[name=old-kw-2]"),
        $old3 = $form.find("[name=old-kw-3]"),
        $old4 = $form.find("[name=old-kw-4]"),
        $old5 = $form.find("[name=old-kw-5]"),
        $old6 = $form.find("[name=old-kw-6]");

    var $new1 = $form.find("[name=new-kw-1]"),
        $new2 = $form.find("[name=new-kw-2]"),
        $new3 = $form.find("[name=new-kw-3]"),
        $new4 = $form.find("[name=new-kw-4]"),
        $new5 = $form.find("[name=new-kw-5]"),
        $new6 = $form.find("[name=new-kw-6]");

    var $rp1 = $form.find("[name=repeat-1]"),
        $rp2 = $form.find("[name=repeat-2]"),
        $rp3 = $form.find("[name=repeat-3]"),
        $rp4 = $form.find("[name=repeat-4]"),
        $rp5 = $form.find("[name=repeat-5]"),
        $rp6 = $form.find("[name=repeat-6]");

    var oldkw = [];
    var newkw = [];
    var newkwrepeat = [];

    // all fields
    $old_input.on("keyup", function(event) 
    {
    	var code = event.keyCode || event.which;
    	if (code === 9 && !event.shiftKey) 
    	{
    		// prevent default event
    		event.preventDefault();    	
    	}
        })
        .inputmask(
        	{
        		mask: "9",
        		placeholder: "",
        		showMaskOnHover: true,
        		showMaskOnFocus: false,
        		clearIncomplete: true,
        		onincomplete: function() {
                !debug || console.log("inputmask incomplete");
            },
            oncleared: function() 
            {
                var index = $old_input.index(this),
                    prev = index - 1,
                    next = index + 1;
                
                if (prev >= 0) 
                {
                    // focus field
                    $old_input.eq(prev).focus();
                } 
                
               

                !debug || console.log("[oncleared]", prev, index, next,oldkw);
            },
            onKeyValidation: function(key, result) 
            {
            	if(result)
            	{
                    var index = $old_input.index(this),
                    prev = index - 1,
                    next = index + 1;

                // focus to next field
                if (prev < 6) 
                {
                    $old_input.eq(next).focus();
                }
                oldkw[index] = $old_input.eq(index).val();
                !debug ||console.log("[onKeyValidation]", index,key, result, oldkw);
            	}

            },
            onBeforePaste: function(data, opts) 
            {
                $.each(data.split(""), function(index, value) 
                {
                    // set value
                    $old_input.eq(index).val(value);

                    !debug || console.log("[onBeforePaste:each]",index, value);
                });

                return false;
            }
        });

});