var deviceID;
var cycleKitModel;
var serialModel;
var appVersion;
var libraryVersion;
var ipAddress;
var subnetMask;
var gateway;
var MAC;

var st=setTimeout('CheckButton()', 100);

function updateAboutPage(){
	updateDeviceID();
	updateModelNumber();
	updateSerialNumber();
	updateAppVersion();
	updateLibraryVersion();
	updateIP();
	updateSubnet();
	updateGateway();
	updateGateway();
	updateMAC();
}

function doPost()
{	
	if(locked)
	{
		keywordAttempt();
	}
	console.log("FIRMWARE UPDATING");
	//sendMessage("FIRMWARE UPDATING");
	sendMessage(socket, "FIRMWARE UPDATING");

	clearTimeout(st);
	var bt=document.getElementById('Accept');
	bt.disabled=true;
	Form1.method='POST';
	Form1.submit();
	

}

function checkFileExt()
{
	file = document.getElementById("DryerNewFirmWare");
	var fileName = file.value.replace(/^.*[\\\/]/, '');
	if(!(fileName.startsWith("CK-v") && fileName.endsWith(".pgz")))
	{
	    alert('Please Select a file that begins with CK-v and ends with .pgz.');
		ext.value='';
	}
	else
	{
		CheckButton();
	}
}
function CheckButton() 
{
	console.log("ENABLE FLASH BUTTON");
	var bt=document.getElementById('Accept');
	if(bt!=null) 
	{
		if(document.getElementById('DryerNewFirmWare').value=='')
		{
			bt.disabled=true;
				console.log("true");
		}
		 else
		 {		
			bt.disabled=false;
				console.log("false");
		 }
	} 
	//st=setTimeout('CheckButton()', 100);
}

function checkInputSize()
{
	if(document.getElementById('input-device-id').value.length == 0)
	{
		document.getElementById('device-id-save').disabled = true;
	}
	else{
		document.getElementById('device-id-save').disabled = false;
	}
	
}

function updateLockIcon() {
	if (unlocked) {
		document.getElementById('lockIcon').style.display = 'none';
		document.getElementById('unlockIcon').style.display = 'block';
	}
	else {
		document.getElementById('lockIcon').style.display = 'block';
		document.getElementById('unlockIcon').style.display = 'none';
	}
}

function displayCurrentFirmwareVersion()
{
	document.getElementById('currentVersionCell').innerHTML = "&nbsp Firmware Version:&nbsp"+cycleKit.fimwareVersion+" &nbsp &nbsp Library Version:&nbsp" + cycleKit.libraryVersion;
}

function updateDeviceID() {
	
	deviceId = cycleKit.deviceID;
	document.getElementById('device-id').innerHTML = deviceId;
}

function updateModelNumber() {
	
	cycleKitModel = cycleKit.cycleKitModel;
	document.getElementById('model').innerHTML = cycleKitModel;
}

function updateSerialNumber() {
	
	serialModel = cycleKit.serialNumber;
	document.getElementById('serial-number').innerHTML = serialModel;
}

function updateAppVersion() {
	
	appVersion = cycleKit.appVersion;
	document.getElementById('app-version').innerHTML = appVersion;
}

function updateLibraryVersion() {
	
	libraryVersion = cycleKit.libraryVersion;
	document.getElementById('library-Version').innerHTML = libraryVersion;
}

function updateIP() {
	ipAddress = cycleKit.ipAddress;
	document.getElementById('ip-address').innerHTML = ipAddress;
	
}
function updateSubnet() {
	subnetMask = cycleKit.subnetMask;
	document.getElementById('subnet').innerHTML = subnetMask;
}
function updateGateway() {
	gateway = cycleKit.gateway;
	document.getElementById('gateway').innerHTML = gateway;
}

function updateMAC() {
	MAC = cycleKit.mac;
	document.getElementById('mac-address').innerHTML = MAC;
}

function setDeviceId(){
		
	if(locked)
	{
		keywordAttempt();
	}
	deviceId = document.getElementById('input-device-id').value;
	
	sendCommand(socket, "SET DEVICE ID",deviceId);
	console.log("SET DEVICE ID");
}

function loadDeviceIdModal()
{
	clearInput('input-device-id');
	document.getElementById('device-id-save').disabled = true;
}



