var cycleKit = null;
var unlocked = false;
var socket;



Number.prototype.pad = function (size) {
	var s = String(this);
	while (s.length < (size || 2)) { s = "0" + s; }
	return s;
}














































































var pressureUnits = "PSI" // default
var flowUnits = "SCFD"
var tempUnits = "&degF" 
var minFlow = 0.0;
var maxFlow = 6500.0;
var minHighOutlet = 0.4;
var maxHighOutlet = 20.0;
var minLowOutlet = 0.3;
var maxLowOutlet = 19.9;
var defaultFlow = 4500;
var defaultHighOutlet = 20.0;
var defaultLowOutlet = 0.3;


function units()
{

	if(cycleKit.sensors.metricUnitsEnabled == true)
	{
		minFlow = 0.0;
		maxFlow = 184.1;
		minHighOutlet = 3;
		maxHighOutlet = 137;
		minLowOutlet = 2;
		maxLowOutlet = 136;
		defaultFlow = 127.4;
		defaultHighOutlet = 137;
		defaultLowOutlet = 2;

		document.getElementById('lopUnit').innerHTML = "KPA"
		document.getElementById('hopUnit').innerHTML = "KPA"
		document.getElementById('hfUnits').innerHTML = "SCMD"

		document.getElementById('defaultHOP').innerHTML = defaultHighOutlet
		document.getElementById('HOPRange').innerHTML = minHighOutlet+ " - "+maxHighOutlet;

		document.getElementById('defaultLOP').innerHTML = defaultLowOutlet
		document.getElementById('LOPRange').innerHTML = minLowOutlet+ " - "+maxLowOutlet;

		document.getElementById('defaultFlow').innerHTML = defaultFlow
		document.getElementById('flowRange').innerHTML = minFlow+ " - "+maxFlow;

	}
	else
	{
		minFlow = 0.0;
		maxFlow = 6500.0;
		minHighOutlet = 0.4;
		maxHighOutlet = 20.0;
		minLowOutlet = 0.3;
		maxLowOutlet = 19.9;
		defaultFlow = 4500;
		defaultHighOutlet = 20.0;
		defaultLowOutlet = 0.3;
		document.getElementById('lopUnit').innerHTML = "PSI"
		document.getElementById('hopUnit').innerHTML = "PSI"
		document.getElementById('hfUnits').innerHTML = "SCFD"

				document.getElementById('defaultHOP').innerHTML = defaultHighOutlet
		document.getElementById('HOPRange').innerHTML = minHighOutlet+ " - "+maxHighOutlet;

		document.getElementById('defaultLOP').innerHTML = defaultLowOutlet
		document.getElementById('LOPRange').innerHTML = minLowOutlet+ " - "+maxLowOutlet;

		document.getElementById('defaultFlow').innerHTML = defaultFlow
		document.getElementById('flowRange').innerHTML = minFlow+ " - "+maxFlow;


	}
}

function getPressureUnits()
{
	return pressureUnits;
}
function getFlowUnits()
{
	return pressureUnits;
}

function withinRange(low, high, number) {
	if(number < low){
		return false;
	}
	else if (number > high) {
		return false;
	}
	return true;
}
/*
 * Validation functions
 */
function isValidIP(ipString) {
	re = /^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$/

	if (ipString != '') {
		if (ipString.match(re)) {
			return true
		}
		else {
			return false;
		}
	}
	return false;

}
function isValidSubnet(sn) {
	sn = sn.replace(/\s/g, '');
	console.log(sn);
	if (
		sn == "255.0.0.0" ||
		sn == "255.255.240.0" ||
		sn == "255.128.0.0" ||
		sn == "255.255.248.0" ||
		sn == "255.192.0.0" ||
		sn == "255.255.252.0" ||
		sn == "255.224.0.0" ||
		sn == "255.255.254.0" ||
		sn == "255.240.0.0" ||
		sn == "255.255.255.0" ||
		sn == "255.248.0.0" ||
		sn == "255.255.255.128" ||
		sn == "255.252.0.0" ||
		sn == "255.255.255.192" ||
		sn == "255.254.0.0" ||
		sn == "255.255.255.224" ||
		sn == "255.255.0.0" ||
		sn == "255.255.255.240" ||
		sn == "255.255.128.0" ||
		sn == "255.255.255.248" ||
		sn == "255.255.192.0" ||
		sn == "255.255.255.252" ||
		sn == "255.255.224.0"
	) {

		return true;
	}
	else {
		return false;
	}
}
function isValidDate(dateString) {
	// First check for the pattern
	if (!/^\d{1,2}\/\d{1,2}\/\d{4}$/.test(dateString))
		return false;


	// Parse the date parts to integers
	var parts = dateString.split("/");
	var day = parseInt(parts[1], 10);
	var month = parseInt(parts[0], 10);
	var year = parseInt(parts[2], 10);

	// Check the ranges of month and year
	if (year < 1000 || year > 3000 || month == 0 || month > 12)
		return false;

	var monthLength = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];

	// Adjust for leap years
	if (year % 400 == 0 || (year % 100 != 0 && year % 4 == 0))
		monthLength[1] = 29;

	// Check the range of the day
	return day > 0 && day <= monthLength[month - 1];
};
function checkCompRuntimeFormat(form) {
	re = /^(0[1-9]|[1-5]?[0-9]):[0-5][0-9]$/
	if (form.value != '') {
		if (regs = form.value.match(re)) {
			return true;
		}
		else {
			return false;
		}
	}
	else {
		return false;
	}
}
function checkTimeFormat(form) {
	re = /^(0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$/
	if (form.value != '') {
		if (regs = form.value.match(re)) {
			if (regs[1] > 23 || regs[2] > 59) {
				return false;
			}
			else {
				return true;
			}
		}
		else {
			return false;
		}
	}
	else {
		return false;
	}
}
/*
 * End of Validation functions
 */




function setCycleTime(event) {

	var cycleTime = document.getElementById('cycle_time');
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			if (checkTimeFormat(cycleTime)) {
				sendCommand(socket,"SET CYCLE TIME", cycleTime.value);
				cycleTime.blur()

			}
			else {
				cycleTime.blur();
				alert("Incorrect Time Format (Use HH(0-24):mm(0-59))");
			}
		}
	}
}
function setAlarmDelay(enabled) {
	if (isUnlocked()) {
		if (enabled) {
			sendCommand(socket,"ALARM DELAY ENABLE", "TRUE");
			document.getElementById('delay_on').checked = true;
			document.getElementById('delay_off').checked = false;
		}
		else {
			sendCommand(socket,"ALARM DELAY ENABLE", "FALSE");
			document.getElementById('delay_on').checked = false;
			document.getElementById('delay_off').checked = true;
		}
	}


}
function setStartupDelay() {
	if (isUnlocked()) {
		var startupDelay = document.getElementById('startup_delay');
		var delay = startupDelay.options[startupDelay.selectedIndex].value;
		sendCommand(socket,"SET STARTUP DELAY", delay);
	}
}
function setUnits() {
	if (isUnlocked()) {
		var units = document.getElementById('unit-dropdown');
		var unitType = units.options[units.selectedIndex].value;
		console.error(unitType)
		sendCommand(socket,"SET UNITS", unitType);
	}
}
function setDate(event) {
	var date = document.getElementById('current_date');
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			if (isValidDate(date.value)) {
				sendCommand(socket,"SET DATE", date.value);
				date.blur()
			}
			else {
				date.blur();
				alert("Incorrect Date Format (Use mm/dd/yyyy)");
			}
		}
	}
}
function setTime(event) {
	var time = document.getElementById('current_time');
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			if (checkTimeFormat(time)) {
				sendCommand(socket,"SET TIME", time.value);
				time.blur()
			}
			else {
				time.blur();
				alert("Incorrect Time Format (Use HH(0-24):mm(0-59))");
			}
		}
	}
}
function setDeviceID(event) {
	var devId = document.getElementById('device_id');
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			if (devId.value.length < 16) {
				sendCommand(socket,"SET DEV ID", devId.value);
				devId.blur();
			}
			else {
				alert("Device ID too long. 16 character limit");
				devId.blur();
			}
		}

	}

}
function setHighOutletPressureThreshold(event) {

	var input = document.getElementById('high_outlet_alarm');

	if (event.key === 'Enter') {
		if (isUnlocked()) {
			if (isNaN(input.value)) {
				alert("Please Enter a Number");
				input.blur();
				return;
			}

			if (withinRange(minHighOutlet, maxHighOutlet, input.value)) {
				sendCommand(socket,"SET HIGH OUTLET PRESSURE THRESHOLD", input.value);
			}
			else {
				alert("Input out of range")
			}

			input.blur()
		}
	}
}
function setLowOutletPressureThreshold(event) {
	var input = document.getElementById('low_outlet_alarm');
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			if (isNaN(input.value)) {
				alert("Please Enter a Number");
				input.blur();
				return;
			}
			if (withinRange(minLowOutlet, maxLowOutlet, input.value)) {
				sendCommand(socket,"SET LOW OUTLET PRESSURE THRESHOLD", input.value);
			}
			else {
				alert("Input out of range")
			}
			input.blur();
		}
	}
}
function setHighFlowThreshold(event) {
	var input = document.getElementById('high_flow_alarm');
	var threshold = input.value;
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			if (isNaN(input.value)) {
				alert("Please Enter a Number");
				input.blur();
				return;
			}
			if (withinRange(minFlow, maxFlow, input.value)) {
				sendCommand(socket,"SET HIGH FLOW THRESHOLD", input.value);
			}
			else {
				alert("Input out of range");
			}

				input.blur();
	
		}
	}
}
function setHighHumidityThreshold(event) {
	var input = document.getElementById('high_humidity_alarm');
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			if (isNaN(input.value)) {
				alert("Please Enter a Number");
				input.blur();
				return;
			}
			if (withinRange(3.0, 15.0, input.value)) {
				sendCommand(socket,"SET HIGH HUMIDITY THRESHOLD", input.value);
			}
			else {
				alert("Input out of range")
			}
			input.blur();
		}
	}
}
function setHighDutyThreshold(event) {
	var input = document.getElementById('high_duty_alarm');
	if (event.key === 'Enter') {
		if (isUnlocked()) 
		{
			if (isNaN(input.value)) 
			{
				alert("Please Enter a Number");
				input.blur();
				return;
			}
			if (Number.isInteger(+input.value)) 
			{
				if (withinRange(1, 99, input.value))
				{
					sendCommand(socket,"SET HIGH DUTY THRESHOLD", input.value);
				}
				else 
				{
					alert("Input out of range")
				}
			}
			else
			{
				alert("Please enter an Integer")
			}

			input.blur();
		}
	}
}

function setHighCompRuntime(event) {
	var input = document.getElementById('high_comp_run_alarm');
	var threshold = input.value;
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			if (checkCompRuntimeFormat(document.getElementById('high_comp_run_alarm'))) {
				console.log(threshold);
				sendCommand(socket,"SET HIGH COMP RUNTIME THRESHOLD", threshold);
				input.blur();
			}
			else {
				alert("Incorrect Format. Enter time in mm:ss, between 01:00 and 59:59");
				input.blur();
			}
		}
	}
}

function setIP(event) {
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			var ip = document.getElementById('ip_address');
			if (isValidIP(ip.value)) {
				sendCommand(socket,"SET IP", ip.value);
				ip.blur();
			}
			else {
				alert("Incorrect IP Format");
				ip.blur();
			}
		}
	}
}
function setGateway(event) {
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			var gw = document.getElementById('gateway_address');
			if (isValidIP(gw.value)) {
				sendCommand(socket,"SET GATEWAY", gw.value);
				gw.blur();
			}
			else {
				alert("Incorrect Gateway Format");
				gw.blur();
			}
		}
	}
}
function setSNMPADDR(event) {
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			var gw = document.getElementById('snmp_address');
			if (isValidIP(gw.value)) {
				sendCommand(socket,"SET SNMP", gw.value);
				gw.blur();
			}
			else {
				alert("Incorrect SNMP TRAP Format");
				gw.blur();
			}
		}
	}
}
function setSubnet(event) {
	if (event.key === 'Enter') {
		if (isUnlocked()) {
			var sn = document.getElementById('subnet_mask');
			if (isValidSubnet(sn.value)) {
				sendCommand(socket,"SET SUBNET", sn.value);
				sn.blur();
			}
			else {
				alert("Incorrect Subnet Mask format");
				sn.blur();
			}
		}
	}

}


function changeKeyword() {
	var kwAttempt = prompt("Enter old keyword");
	if (kwAttempt == cycleKit.keyword.pad(6)) {
		newKW = prompt("Enter new Keyword");
		console.log(newKW);
		re = /^[0-9]{6}$/;
		if (newKW.match(re)) {
			sendCommand(socket,"CHANGE KEYWORD", newKW);
		}
		else {
			alert("Incorrect Keyword Format. Enter a 5-digit Integer")
		}
	}
	else {
		alert("Incorrect Keyword")
	}



}
function resetToFactoryDefaults() {
	var answer = confirm("Are you sure?");

	if (answer) {
		sendMessage(socket,"RESET TO FACTORY DEFAULT");
	}

}


function updateNetworkInfo() {
	updateIP();
	updateSubnet();
	updateGateway();
	updateSNMPTrap();
}
function updateThresholds() {
	updateHighOutletPressureThreshold();
	updateLowOutletPressureThreshold();
	updateHighFlowThreshold();
	updateHighHumidityThreshold();
	updateHighRuntimeThreshold();
	updateDutyThreshold();

}
function updateSystemSetupTable() {
	updateUnits();
	updateCycleMode();
	updateCycleTime();
	updateAlarmDelayEnabled();
	updateStartupDelayEnabled();
	updateDate();
	updateDeviceID();
}
function updateIP() {
	var ip = cycleKit.network.ipstring;
	ip = ip.substring(0, ip.indexOf('/'));

	if (document.getElementById('ip_address') != document.activeElement) {
		document.getElementById('ip_address').value = ip;
	}

}
function updateSubnet() {
	var subnet = cycleKit.network.subnetString;
	if (document.getElementById('subnet_mask') != document.activeElement) {
		document.getElementById('subnet_mask').value = subnet;
	}
}
function updateGateway() {
	if (document.getElementById('gateway_address') != document.activeElement) {
		document.getElementById('gateway_address').value = cycleKit.network.gatewayString;
	}

}

function updateSNMPTrap() {
	if (document.getElementById('snmp_address') != document.activeElement) {
		document.getElementById('snmp_address').value = cycleKit.network.snmpstring;
	}

}
function updateHighOutletPressureThreshold() {
	var hop = document.getElementById('high_outlet_alarm');
	if (hop != document.activeElement) {
		if(cycleKit.sensors.metricUnitsEnabled == true)
		{
			hop.value = cycleKit.highOutletPressureThreshold.toFixed(0);
		}
		else
		{
			hop.value = cycleKit.highOutletPressureThreshold.toFixed(1);
		}
		
	}
}
function updateDutyThreshold() {
	var duty = document.getElementById('high_duty_alarm');
	if (duty != document.activeElement) {
		duty.value = cycleKit.highDutyCycleThreshold.toFixed(0);
	}
}
function updateLowOutletPressureThreshold() {
	var lop = document.getElementById('low_outlet_alarm');
	if (lop != document.activeElement) {
		if(cycleKit.sensors.metricUnitsEnabled == true)
		{
			lop.value = cycleKit.lowOutletPressureThreshold.toFixed(0);
		}
		else
		{
			lop.value = cycleKit.lowOutletPressureThreshold.toFixed(1);
		}
		
	}
}
function updateHighFlowThreshold() {
	var hf = document.getElementById('high_flow_alarm');
	if (hf != document.activeElement) {
		hf.value = cycleKit.highFlowThreshold.toFixed(1);
	}
}
function updateHighHumidityThreshold() {
	var hh = document.getElementById('high_humidity_alarm');
	if (hh != document.activeElement) {
		hh.value = cycleKit.highHumidityThreshold.toFixed(1);
	}
}
function updateHighRuntimeThreshold() {
	var hcr = document.getElementById('high_comp_run_alarm');
	if (hcr != document.activeElement) {
		hcr.value = cycleKit.highCompressorLastRuntimeThresholdMinutes.pad() + ":" + cycleKit.highCompressorLastRuntimeThresholdSeconds.pad();
	}

}
function updateDeviceID() {
	if (document.getElementById('device_id') != document.activeElement) {
		var id = cycleKit.deviceID.replace(/\0/g, '');
		document.getElementById('device_id').value = id;
	}

}
function updateDate() {
	if (document.getElementById('current_date') != document.activeElement) {
		document.getElementById('current_date').value = cycleKit.date;
	}
	if (document.getElementById('current_time') != document.activeElement) {
		document.getElementById('current_time').value = cycleKit.time;
	}
}
function updateStartupDelayEnabled() {
	if (cycleKit.startupDelay == 0) {
		document.getElementById('startup_delay').selectedIndex = 0;
	}
	else if (cycleKit.startupDelay == 1) {
		document.getElementById('startup_delay').value = cycleKit.startupDelay + " SECOND";
	}
	else {
		document.getElementById('startup_delay').value = cycleKit.startupDelay + " SECONDS";
	}
}
function updateUnits() {

	if (cycleKit.sensors.metricUnitsEnabled == false) {
		document.getElementById('unit-dropdown').selectedIndex = 0;
	}
	else 
	{
		document.getElementById('unit-dropdown').selectedIndex = 1;
	}

}
function updateAlarmDelayEnabled() {
	if (cycleKit.alarmDelayEnabled == true) {
		document.getElementById('delay_on').checked = true;
		document.getElementById('delay_off').checked = false;
	}
	else {
		document.getElementById('delay_on').checked = false;
		document.getElementById('delay_off').checked = true;
	}
}
function updateCycleTime() {
	var cycleTime = document.getElementById('cycle_time');
	if (cycleTime != document.activeElement) {
		cycleTime.value = cycleKit.cycleTimeHours.pad() + ":" + cycleKit.cycleTimeMinutes.pad();
	}
}

